% input:  a set of nodes
% output: that same set of nodes, but with the beliefs set appropriately.
% Sept. 3, 2003  billf.

function nodes = computeBeliefs(nodes);

% Go through every link, and transmit messages near to far
% ----------------------------------------------------------------
fprintf(1, '\nSetting beliefs for %d nodes:\n', length(nodes)); tic;
% ----------------------------------------------------------------
for nearIdx = 1:length(nodes);     
    near = nodes{nearIdx};
    belief = near.localEvidence;
    for linkIdx = 1:near.nLinks
        link   = near.links{linkIdx};      
        if ~isempty(link.farsMessageToMe)
            belief = multMessages(belief, link.farsMessageToMe);
        end
    end;
    nodes{nearIdx}.marginal = belief;
end;

fprintf(1,'\nDone setting beliefs: %f secs\n',toc);
