% ipf.m
% test program for ipf toy example.   oct. 11, 2003  wtf created.
initPaths;
nIter = 5;
n = 5;  % number of cells in the marginal.
tmp = rand(n);
blurMat = [0 1 0; 1 2 1; 0 1 0];
joint = conv2(tmp,blurMat, 'same');
joint = joint ./ sum(sum(joint));

marg1 = sum(joint,1);
marg2 = sum(joint,2);

figure;showIm(joint); title('true joint probability');
figure;subplot(2,1,1); plot(marg1); subplot(2,1,2); plot(marg2); title('true marginals')

mp1All = [];
mp2All = [];
proposed = rand(n);
proposed = conv2(proposed,blurMat, 'same');
proposed = proposed ./ sum(sum(proposed));
figure;showIm(proposed); title('initial guess at joint probability');
for i = 1:nIter
    mp1 = sum(proposed,1);
    mp2 = sum(proposed,2);
    mp1All = [mp1All; mp1];
    mp2All = [mp2All, mp2];
    
    proposed = proposed .* repmat((marg1 ./ mp1), n, 1);
    proposed = proposed .* repmat((marg2 ./ mp2), 1, n);
    proposed = proposed ./ sum(sum(proposed));
end

figure;plot(mp1All', 'r'); hold on
plot(marg1', 'b'); 
plot(marg1' - mp1', 'y'); hold off
title('marg1 (b) versus estimates (r) and final difference (y)');

figure;plot(mp2All, 'r'); hold on
plot(marg2, 'b'); 
plot(marg2 - mp2, 'y'); hold off
title('marg2 (b) versus estimates (r) and final difference (y)');

figure; showIm({joint; proposed}); title('true joint (top) and IPF estimate (bottom)')

    